// implementing a better system



// mafia


//projectile
AddDamageType("pushhammer",   '<bitmap:add-ons/ci/pushhammer> %1',    '%2 <bitmap:add-ons/ci/pushhammer> %1',1,1);
datablock ProjectileData(mafiahammerProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   //directDamage        = 2;
   //directDamageType  = $DamageType::pushhammer;
   //radiusDamageType  = $DamageType::pushhammer;
   //explosion           = pushhammerExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   //impactImpulse	     = 100;
   //verticalImpulse	  = 100;

   armingDelay         = 0;
   lifetime            = 1070;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(mafiahammerItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/hammer.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "mafiahammer";
	iconName = "./pushhammer";
	doColorShift = true;
	colorShiftColor = "0.471 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = mafiahammerImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(mafiahammerImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some mafias into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = mafiahammerItem;
   ammo = " ";
   projectile = mafiahammerProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.471 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.0;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 0.6;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	//stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function mafiahammerImage::onPreFire(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'pushhammer prefired!!!');
	//Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, shiftleft);
}

function mafiahammerImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function mafiahammerProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{				
	if(!isobject(%col)){
		return;
	}
	if(%col.getclassname() $= "Player" || %col.getclassname() $= "AIPlayer"){
		if(!%col.client.ismafia && !%col.client.isvillage){
			return;
		}
		if(!%obj.client.isturn){
			messageclient(%obj.client,'',"This hammer serves no use for you.");
			return;
		}
		if(%obj.client.mafiajob $= "mafia" && !%col.client.ismafia){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0kill" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to end turn.");
			%obj.client.mafiapick=%col.client;
		}
		if(%obj.client.mafiajob $= "vigilante"){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0kill" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to no-kill.");
			%obj.client.mafiapick=%col.client;
		}
		if(%obj.client.mafiajob $= "tracker"){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0track" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to end turn.");
			%obj.client.mafiapick=%col.client;
		}
		if(%obj.client.mafiajob $= "fool"){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0visit" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to end turn.");
			%obj.client.mafiapick=%col.client;
		}
		if(%obj.client.mafiajob $= "shrink"){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0shrink" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to end turn.");
			%obj.client.mafiapick=%col.client;
		}
		if(%obj.client.mafiajob $= "yakuza" && !%col.client.ismafia){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0convert" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to end turn.");
			%obj.client.mafiapick=%col.client;
		}
		if(%obj.client.mafiajob $= "detective"){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0search" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to end turn.");
			%obj.client.mafiapick=%col.client;
		}
		if(%obj.client.mafiajob $= "doctor"){
			messageclient(%obj.client,'',"\c2Are you sure you want to \c0heal" SPC %col.client.name @ "\c2? /mafiayes or attack another target. /mafiano to end turn.");
			%obj.client.mafiapick=%col.client;
		}
		return;
	}
	
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}


function servercmdmafiano(%client){
	if(!%client.isturn){
		messageclient(%client,'',"It is not your turn!");
		return;
	}
		announce("The person returns to sleep.");
		cancel($mafianextturn);
		nextmafiaturn();
}
function servercmdmafiayes(%client){
	if(!%client.isturn){
		messageclient(%client,'',"It is not your turn!");
		return;
	}
	announce("The person returns to sleep.");
	if(%client.mafiajob $= "mafia"){
		%client.mafiapick.goingtodie=1;
		messageclient(%client,'',%client.mafiapick.name SPC "will die tonight.");
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		cancel($mafianextturn);
		nextmafiaturn();
	}
	if(%client.mafiajob $= "vigilante"){
		%client.mafiapick.goingtodie=1;
		messageclient(%client,'',%client.mafiapick.name SPC "will die tonight.");
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		cancel($mafianextturn);
		nextmafiaturn();
	}
	if(%client.mafiajob $= "yakuza"){
		%client.mafiapick.goingtoconvert=1;
		messageclient(%client,'',%client.mafiapick.name SPC "will be converted tonight.");
		%client.goingtodie=1;
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		cancel($mafianextturn);
		nextmafiaturn();
	}
	if(%client.mafiajob $= "doctor"){
		%client.mafiapick.healed=1;
		messageclient(%client,'',%client.mafiapick.name SPC "will be healed tonight and cannot die.");
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		cancel($mafianextturn);
		nextmafiaturn();
	}
	if(%client.mafiajob $= "shrink"){
		%client.mafiapick.shrunk=1;
		messageclient(%client,'',%client.mafiapick.name SPC "will be shrunk tonight and cannot convert.");
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		cancel($mafianextturn);
		nextmafiaturn();
	}
	if(%client.mafiajob $= "fool"){
		%client.mafiapick.shrunk=1;
		messageclient(%client,'',%client.mafiapick.name SPC "will be visited tonight.");
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		cancel($mafianextturn);
		nextmafiaturn();
	}
	if(%client.mafiajob $= "detective"){
		if(%client.mafiapick.ismafia){
			%wheth = "part of the mafia";
		}else{
			%wheth= "not part of the mafia";
		}
		//messageclient(%client,'',%client.mafiapick.name SPC "is" SPC %wheth @ ".");
		%client.mafcheck=%client.mafiapick.name SPC "is" SPC %wheth @ ".";
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		%client.goingtocheck=1;
		cancel($mafianextturn);
		nextmafiaturn();
	}
	if(%client.mafiajob $= "tracker"){
		%client.goingtotrack=1;
		$Mafia_trackerreport[%client]= %client.name SPC "visited" SPC %client.mafiapick.name;
		cancel($mafianextturn);
		nextmafiaturn();
	}
}



function nextmafiaturn(){
	$Mafia_client[$Mafia_turn].isturn=0;
	$Mafia_turn++;
	if($mafia_turn==1){
		announce("It is now night, you may not talk. You will take turns waking up and doing your job.");
	}else{

			%client=$mafia_client[$mafia_turn-1];
			%temp=new StaticShape() {
				position="0 0 -300";
				scale="0.001 0.001 0.001";
				dataBlock=LCD;
			};
			missionCleanup.add(%temp);
			%cam=%client.camera;
			%client.setcontrolobject(%cam);
        		%cam.setOrbitMode(%temp,"0 0 -300",0,0,0,0);
			%temp.delete();
	}
	$mafia_isnight=1;
	if($Mafia_turn>$Mafia_endturn+1){
		//end
	$mafia_mafiacount=0;
	$mafia_villagecount=0;
	for(%i=0;%i<ClientGroup.getCount();%i++){
		%cl = ClientGroup.getObject(%i);
		if(!%cl.dead){
			if(%cl.ismafia){
				$mafia_mafiacount++;
			}else if(%cl.isvillage){
				$mafia_villagecount++;
			}
		}
	}
		$mafia_isnight=0;
		for(%i=0;%i<ClientGroup.getCount();%i++){
			%cl = ClientGroup.getObject(%i);
			if(!%cl.ismafia && !%cl.isvillage){
				%cl.goingtodie=1;
			}
			if(%cl.goingtoconvert && !%cl.shrunk){
				messageclient(%cl,'',"<font:impact:60>You are now a member of the mafia(you were converted by a yakuza.");
				%cl.ismafia=1;
				%cl.isvillage=0;
				%cl.mafiajob="mafia";
				$Mafia_mafiacount++;
			}
			if(%cl.goingtodie && !%cl.protected && !%cl.healed){
				Announce(%cl.name SPC "the" SPC %cl.mafiajob SPC "died during the night.");
				%cl.dead=1;
				$mafia_deads++;
				if(%cl.ismafia){
					$Mafia_mafiacount--;
				}else if(%cl.isvillage){
					$Mafia_villagecount--;
				}
			}
			if(%cl.goingtocheck){
				messageclient(%cl,'',"<font:impact:60>\c2You suspect that" SPC %cl.mafcheck);
			}
			if(%cl.goingtotrack){	
				messageclient(%cl,'',"<font:impact:60>\c2" SPC $Mafia_trackerreport[%cl.mafiapick]);
			}
			%cl.mafcheck=0;
			%cl.goingtocheck=0;
			%cl.shrunk=0;
			%cl.protected=0;
			%cl.healed=0;
			%cl.goingtodie=0;
			%cl.goingtoconvert=0;
			%cl.goingtotrack=0;
			if(!%cl.dead){
				%cl.setControlObject(%cl.player);
				%cl.camera.scopeToClient(%cl);
				%alivelist = %alivelist SPC %cl.name;
			}else{
				%cl.player.settransform("0 0 -9000");
			}
		}
		announce("Players left:" @ %alivelist);
		if($mafia_mafiacount >= $mafia_villagecount){
			announce("Mafia outnumbers the village, mafia win.");
			return;
		}
		if(!$mafia_mafiacount){
			announce("No mafia, village win.");
			return;
		}
		$Mafia_voting=1;
		announce("Cast your votes on who should be lynched! /mafiavote playername");
	cancel($mafia_voteendsched);
	cancel($mafia_votewarnsched);
		$mafia_votewarnsched=schedule(120000,0,mafiawarnendvotes);
		$mafia_voteendsched=schedule(180000,0,Mafiaendvotes);
		$Mafia_turn=0;
		return;
	}
	if(!isobject($Mafia_client[$Mafia_turn]) || $Mafia_client[$Mafia_turn].dead){
		nextmafiaturn();
		return;
	}
	%client=$mafia_client[$Mafia_turn];
	%client.isturn=1;
	announce("Someone wakes up.");
	echo(%client.name);
	%client.votes=0;
	cancel($mafianextturn);
	if($Mafia_client[$Mafia_turn].mafiajob $= "mafia"){
		messageclient(%client,'',"You wake up. You are a mafia, select one person to kill. You have one minute");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "vigilante"){
		messageclient(%client,'',"You wake up. You are a vigilante, select one person to kill. <font:impact:60>You want to kill suspicious people that you think are mafia.");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "yakuza"){
		messageclient(%client,'',"You wake up. You are a yakuza, select one person to convert into a mafia(you will die if you choose to convert).");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "tracker"){
		messageclient(%client,'',"You wake up. You are a tracker, select one person to follow.");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "detective"){
		messageclient(%client,'',"You wake up. You are a detective, select one person to search.");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "shrink"){
		messageclient(%client,'',"You wake up. You are a shrink, select one person to shrink. They cannot be converted tonight.");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "doctor"){
		messageclient(%client,'',"You wake up. You are a doctor, select one person to heal. They cannot die tonight.");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "fool"){
		messageclient(%client,'',"You wake up. You are a fool, select one person to visit. Nothing happens to that person when you visit them. You want to be lynched during the day to win.");
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(60000,0,nextmafiaturn);
	}
	if($Mafia_client[$Mafia_turn].mafiajob $= "civ"){
		messageclient(%client,'',"You wake up. You are a civilian. You do nothing this turn. Say /mafiano");
		//%client.isturn=0;
		%client.setControlObject(%client.player);
		%client.camera.scopeToClient(%client);
		$mafianextturn= schedule(30000,0,nextmafiaturn);
	
	}

	
}

function mafiacancel(){
		cancel($mafia_voteendsched);
	cancel($mafia_votewarnsched);
}

function mafiawarnendvotes(){
	announce("1 minute remaining! /mafiavote playername");
}

function mafiaendvotes(){
	announce("Voting time is up!");
	$mafia_voting=0;
	$mafia_mafiacount=0;
	$mafia_villagecount=0;
	for(%i=0;%i<ClientGroup.getCount();%i++){
		%cl = ClientGroup.getObject(%i);
		if(!%cl.dead){
			if(%cl.ismafia){
				$mafia_mafiacount++;
			}else if(%cl.isvillage){
				$mafia_villagecount++;
			}
		}
	}
	for(%i=0;%i<ClientGroup.getCount();%i++){
		%cl = ClientGroup.getObject(%i);
		%cl.voted=0;
		if(%cl.dead){
			%cl.votes=0;
		}
		%cl.talks=10;
		%temp=new StaticShape() {
			position="0 0 -300";
			scale="0.001 0.001 0.001";
			dataBlock=LCD;
		};
		missionCleanup.add(%temp);
		%cam=%cl.camera;
%cl.setcontrolobject(%cam);
        	%cam.setOrbitMode(%temp,"0 0 -300",0,0,0,0);
		%temp.delete();
		$Mafia_trackerreport[%cl]=%cl.name SPC "visited no one.";
		if(%cl.votes > mceil(($mafia_villagecount+$mafia_mafiacount+$mafia_thirdcount)/2)){
			Announce(%cl.name SPC "the" SPC %cl.mafiajob SPC "was lynched.");
			%cl.dead=1;
			$mafia_deads++;
			%cl.player.settransform("0 0 -9000");
			if(%cl.ismafia){
				$Mafia_mafiacount--;
			}
			if(%cl.isvillage){
				$Mafia_villagecount--;
			}
			if(%cl.mafiajob $= "fool"){
				announce("Fool wins!");
				$mafia_voting=0;
				$mafia_turn=0;
				return;	
			}
			if($Mafia_mafiacount == 0){
				announce("Village wins!");
				$mafia_voting=0;
				$mafia_turn=0;
				return;
			}
			if($Mafia_villagecount == 0){
				announce("Mafia wins!");
				$mafia_voting=0;
				$mafia_turn=0;
				return;
			}
			if($mafia_mafiacount >= $mafia_villagecount){
				announce("Mafia outnumbers the village, mafia win.");
				return;
			}
			if(!$mafia_mafiacount){
				announce("No mafia, village win.");
				return;
			}
		}
	}
	
	$Mafia_turn=0;
	nextmafiaturn();
}

function servercmdstartmafia(%client){
	if(%client.issuperadmin){
		//$Mafia_autostart=1;
		mafiastartup();
	}
}

function mafiajobsoutput(){
	announce("Mafia:" SPC $mafia_jobs["mafia"] SPC "Yakuza:" SPC $Mafia_jobs["yakuza"] SPC "Detective:" SPC $mafia_jobs["detective"] SPC "Civ:" SPC $mafia_jobs["civ"]);
}
$mafia_autostart=1;
function mafiastartup(){
	cancel($mafia_voteendsched);
	cancel($mafia_votewarnsched);
	$mafia_turn=0;
	$mafia_endturn=0;
	$mafia_deads=0;
	$mafia_mafiacount=0;
	$mafia_villagecount=0;
	$mafia_isnight=0;
	//announce(1+mfloor(ClientGroup.getcount()/4));
	if($mafia_autostart){
		$Mafia_jobs["mafia"]=mfloor(ClientGroup.getcount()/4);//i.e with 9 players, 2 maf, 2 det, 5 civ., with 4, 1 1 2
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["yakuza"]){
			$Mafia_jobs["yakuza"]=mfloor($Mafia_jobs["mafia"]/2);
		}else{
			$Mafia_jobs["yakuza"]=0;
		}
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["mafia"]){
			$Mafia_jobs["mafia"]=1+$Mafia_jobs["yakuza"];
		}else{
			$Mafia_jobs["mafia"]=0;
		}
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["detective"]){
			$Mafia_jobs["detective"]=(1+mfloor(ClientGroup.getcount()/8))/2;
		}else{
			$Mafia_jobs["detective"]=0;
		}
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["tracker"]){
			$Mafia_jobs["tracker"]=$Mafia_jobs["detective"];
		}else{
			$Mafia_jobs["tracker"]=0;
		}
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["vigilante"]){
			$Mafia_jobs["vigilante"]=$Mafia_jobs["detective"];
		}else{
			$Mafia_jobs["vigilante"]=0;
		}
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["doctor"]){
			$Mafia_jobs["doctor"]=1+mfloor(ClientGroup.getcount()/8);
		}else{
			$Mafia_jobs["doctor"]=0;
		}
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["shrink"]){
			$Mafia_jobs["shrink"]=$Mafia_jobs["yakuza"];
		}else{
			$Mafia_jobs["shrink"]=0;
		}
		//-----------------------------------------------------------------------------
		if(!$mafia_disable["civ"]){
			$Mafia_jobs["civ"]=1+ClientGroup.getcount() - $Mafia_jobs["mafia"] - $Mafia_jobs["detective"] - $Mafia_jobs["tracker"];
		}else{
			$Mafia_jobs["civ"]=0;
		}
	}	
	if($mafia_usesetup){
		$Mafia_jobs["mafia"]=$mafia_roles[$mafia_currentsetup,"mafia"];
		$Mafia_jobs["yakuza"]=$mafia_roles[$mafia_currentsetup,"yakuza"];
		$Mafia_jobs["civ"]=$mafia_roles[$mafia_currentsetup,"civ"];
		$Mafia_jobs["detective"]=$mafia_roles[$mafia_currentsetup,"detective"];
		$Mafia_jobs["doctor"]=$mafia_roles[$mafia_currentsetup,"doctor"];
		$Mafia_jobs["vigilante"]=$mafia_roles[$mafia_currentsetup,"vigilante"];
		$Mafia_jobs["shrink"]=$mafia_roles[$mafia_currentsetup,"shrink"];
		$Mafia_jobs["tracker"]=$mafia_roles[$mafia_currentsetup,"tracker"];
		$Mafia_jobs["fool"]=$mafia_roles[$mafia_currentsetup,"fool"];
		
		$Mafia_jobs_total = $Mafia_jobs["mafia"] + $Mafia_jobs["yakuza"] + $Mafia_jobs["tracker"] + $Mafia_jobs["civ"]  + $Mafia_jobs["fool"] + $Mafia_jobs["detective"] + $Mafia_jobs["doctor"] + $Mafia_jobs["vigilante"] + $Mafia_jobs["shrink"];
	}
	if(!$legacy_playersort){
	echo("sorting non-legacy");
	%mafneeded = $Mafia_jobs["mafia"];
	%yakneeded = $Mafia_jobs["yakuza"];
	%civneeded = $Mafia_jobs["civ"];
	%detneeded = $Mafia_jobs["detective"];
	%docneeded = $Mafia_jobs["doctor"];
	%traneeded = $Mafia_jobs["tracker"];
	%vigneeded = $Mafia_jobs["vigilante"];
	%shrneeded = $Mafia_jobs["shrink"];
	%fooneeded = $Mafia_jobs["fool"];
	%tf=0;
	while(%tf<500){
		$Mafia_client[%tf]=0;
		%tf++;
	}
	%ds=0;
	while(%ds<$Mafia_jobs_total){
		%Slot_maf[%ds]=0;
		%Slot_vil[%ds]=1;
		if(%mafneeded){
			%Slot[%ds]="mafia";
			%Slot_maf[%ds]=1;
			%Slot_vil[%ds]=0;
			%mafneeded--;
			echo(%ds SPC "maf");

		}else if(%yakneeded){
			%slot[%ds]="yakuza";
			%Slot_maf[%ds]=1;
			%Slot_vil[%ds]=0;
			%yakneeded--;
			echo(%ds SPC "yak");

		}else if(%civneeded){
			%slot[%ds]="civ";
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			%civneeded--;
			echo(%ds SPC "civ");

		}else if(%docneeded){
			%slot[%ds]="doctor";
			%Slot_maf[%ds]=1;
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			%docneeded--;
			echo(%ds SPC "doc");

		}else if(%traneeded){
			%slot[%ds]="tracker";
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			%traneeded--;
			echo(%ds SPC "tra");

		}else if(%detneeded){
			%slot[%ds]="detective";
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			%detneeded--;
			echo(%ds SPC "det");

		}else if(%vigneeded){
			%slot[%ds]="vigilante";
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			%vigneeded--;
			echo(%ds SPC "vig");

		}else if(%shrneeded){
			%slot[%ds]="shrink";
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			%shrneeded--;
			echo(%ds SPC "shr");
		}else if(%fooneeded){
			%slot[%ds]="fool";
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			%shrneeded--;
			echo(%ds SPC "foo");

		}else{
			%slot[%ds]="civ";
			%Slot_maf[%ds]=0;
			%Slot_vil[%ds]=1;
			echo(%ds SPC "civ");
		}
		%ds++;
	}
	%dscount=%ds;
	for(%i=0;%i<ClientGroup.getCount();%i++){
		%cl = ClientGroup.getObject(%i);
		%cl.talks=10;
		%cl.ismafia=0;
		%cl.isvillage=0;
		$Mafia_trackerreport[%cl]=%cl.name SPC "visited no one.";
		%okay=0;
		%cycles=0;
		while(!%okay){
			%okay=0;
			%job=getrandom(0,%dscount);
			%okay = %slot_maf[%job] + %slot_vil[%job];
			if(%slot[%job] $= ""){
				echo("something is wrong" SPC %job);
			}
			%cycles++;
			if(%dscount < 1 || %cycles>=10){
				%forcejob="civ";
				%okay=1;
			}
			
		}
		
		if(!%forcejob){
		%cljob=%slot[%job];
		%cl.mafiajob=%cljob;
		%cl.ismafia=%slot_maf[%job];
		%cl.isvillage=%slot_vil[%job];
		}else{
			%cl.mafiajob=%forcejob;
			%cl.ismafia=0;
			%cl.isvillage=1;
		}

		%dsi=%job;
		while(%dsi<=%dscount){
			%slot[%dsi]=%slot[%dsi+1];
			%slot_maf[%dsi]=%slot_maf[%dsi+1];
			%slot_vil[%dsi]=%slot_vil[%dsi+1];
			%dsi++;
		}
		%slot[%dscount]=0;
		%slot_maf[%dscount]=0;
		%slot_vil[%dscount]=0;
		%dscount--;
		
		%cl.inmafgame=1;
		%cl.votes=0;
		%cl.voted=0;
		%cl.dead=0;
		$Mafia_client[%i+1]=%cl;
		$mafia_endturn++;
		messageclient(%cl,'',"You are a" SPC %cl.mafiajob @ ". #" @ %i+1);
		echo(%cl.name SPC %cl.mafiajob);
		%temp=new StaticShape() {
			position="0 0 -300";
			scale="0.001 0.001 0.001";
			dataBlock=LCD;
		};
		missionCleanup.add(%temp);
		%cam=%cl.camera;
		%cl.setcontrolobject(%cam);
        	%cam.setOrbitMode(%temp,"0 0 -300",0,0,0,0);
		%temp.delete();

	}
	
	}




	if($legacy_playersort){
	echo("sorting-legacy");
	%mafneeded = $Mafia_jobs["mafia"];
	%yakneeded = $Mafia_jobs["yakuza"] + %mafneeded;
	%civneeded = $Mafia_jobs["civ"] + %yakneeded;
	%detneeded = $Mafia_jobs["detective"] + %civneeded;
	%docneeded = $Mafia_jobs["doctor"] + %detneeded;
	%traneeded = $Mafia_jobs["tracker"] + %docneeded;
	%vigneeded = $Mafia_jobs["vigilante"] + %traneeded;
	%shrneeded = $Mafia_jobs["shrink"] + %vigneeded;
	%needed = %shrneeded;
	%tf=0;

	%co_mafs=0;
	%co_civs=0;
	%co_yaks=0;
	%co_dets=0;
	%co_docs=0;
	%co_tras=0;
	%co_vigs=0;
	%co_shrs=0;

	%mafiarating=0;
	%villagerating=0;
	while(%tf<500){
		$Mafia_client[%tf]=0;
		%tf++;
	}
	for(%i=0;%i<ClientGroup.getCount();%i++){
		%cl = ClientGroup.getObject(%i);
		%cl.talks=10;
		$Mafia_trackerreport[%cl]=%cl.name SPC "visited no one.";
		%newneeded = %needed;
		%newneeded -= %co_mafs + %co_yaks + %co_civs + %co_dets + %co_docs + %co_tras + %co_dets + %co_shrs + %co_vigs;
		%job=getrandom(1,%newneeded);
		%hasjob=0;
		if(%job <= %mafneeded && !%hasjob && $Mafia_jobs["mafia"] && %co_mafs < $Mafia_jobs["mafia"]){
			%cl.mafiajob="mafia";
			%cl.ismafia=1;
			%cl.isvillage=0;
			$Mafia_mafiacount++;
			%co_mafs++;
			%hasjob=1;
			%mafiarating+=2;
			%mafneeded--;
			%yakneeded--;
			%civneeded--;
			%detneeded--;
			%docneeded--;
			%traneeded--;
			%vigneeded--;
			%shrneeded--;
		}
		if(%job <= %yakneeded && %job > %mafneeded  && !%hasjob && $Mafia_jobs["yakuza"] && %co_yaks < $Mafia_jobs["yakuza"]){
			%cl.mafiajob="yakuza";
			%cl.ismafia=1;
			%cl.isvillage=0;
			$Mafia_mafiacount++;
			%co_yaks++;
			%hasjob=1;
			%mafiarating+=3;
			%yakneeded--;
			%civneeded--;
			%detneeded--;
			%docneeded--;
			%traneeded--;
			%vigneeded--;
			%shrneeded--;
		}
		if(%job <= %civneeded && %job > %yakneeded  && !%hasjob && $Mafia_jobs["civ"] && %co_civs < $Mafia_jobs["civ"]){
			%cl.mafiajob="civ";
			%cl.ismafia=0;
			%cl.isvillage=1;
			$Mafia_villagecount++;
			%co_civs++;
			%hasjob=1;
			%villagerating+=1;
			%civneeded--;
			%detneeded--;
			%docneeded--;
			%traneeded--;
			%vigneeded--;
			%shrneeded--;
		}
		if(%job <= %detneeded && %job > %civneeded  && !%hasjob && $Mafia_jobs["detective"] && %co_dets < $Mafia_jobs["detective"]){
			%cl.mafiajob="detective";
			%cl.ismafia=0;
			%cl.isvillage=1;
			$Mafia_villagecount++;
			%co_dets++;
			%hasjob=1;
			%villagerating+=4;
			%detneeded--;
			%docneeded--;
			%traneeded--;
			%vigneeded--;
			%shrneeded--;
		}
		if(%job <= %docneeded && %job > %detneeded  && !%hasjob && $Mafia_jobs["doctor"] && %co_docs < $Mafia_jobs["doctor"]){
			%cl.ismafia=0;
			%cl.isvillage=1;
			$Mafia_villagecount++;
			%co_docs++;
			%hasjob=1;
			%villagerating+=2;
			%docneeded--;
			%traneeded--;
			%vigneeded--;
			%shrneeded--;
		}
		if(%job <= %traneeded && %job > %docneeded  && !%hasjob && $Mafia_jobs["tracker"] && %co_tras < $Mafia_jobs["tracker"]){
			%cl.mafiajob="tracker";
			%cl.ismafia=0;
			%cl.isvillage=1;
			$Mafia_villagecount++;
			%co_tras++;
			%hasjob=1;
			%villagerating+=2;
			%traneeded--;
			%vigneeded--;
			%shrneeded--;
		}
		if(%job <= %vigneeded && %job > %traneeded  && !%hasjob && $Mafia_jobs["vigilante"] && %co_vigs < $Mafia_jobs["vigilante"]){
			%cl.mafiajob="vigilante";
			%cl.ismafia=0;
			%cl.isvillage=1;
			$Mafia_villagecount++;
			%co_vigs++;
			%hasjob=1;
			%villagerating+=3;
			%vigneeded--;
			%shrneeded--;
		}
		if(%job <= %shrneeded && %job > %vigneeded  && !%hasjob && $Mafia_jobs["shrink"] && %co_shrs < $Mafia_jobs["shrink"]){
			%cl.mafiajob="shrink";
			%cl.ismafia=0;
			%cl.isvillage=1;
			$Mafia_villagecount++;
			%co_shrs++;
			%hasjob=1;
			%villagerating+=1;
			%shrneeded--;
		}
		%cl.inmafgame=1;
		%cl.votes=0;
		%cl.voted=0;
		%cl.dead=0;
		$Mafia_client[%i+1]=%cl;
		$mafia_endturn++;
		messageclient(%cl,'',"You are a" SPC %cl.mafiajob @ ". #" @ %i+1);
		%temp=new StaticShape() {
			position="0 0 -300";
			scale="0.001 0.001 0.001";
			dataBlock=LCD;
		};
		missionCleanup.add(%temp);
		%cam=%cl.camera;
		%cl.setcontrolobject(%cam);
        	%cam.setOrbitMode(%temp,"0 0 -300",0,0,0,0);
		%temp.delete();

		%needed = %shrneeded;
	}
	}
	if(!$mafia_usesetup){
	if($mafia_mafiacount <= 0 || $mafia_villagecount <= 0 || $mafia_mafiacount > $mafia_villagecount || %mafiarating > %villagerating || %villagerating - 1 < %mafiarating || %co_civs > %co_tras + 1 || %co_civs > %co_docs + 1 || %co_yaks > 2 || %co_dets > 1 || %co_vigs > 1 || %co_docs > 2){
		//announce("No maf/no vil- restart");
		mafiastartup();
		return;
	}
	}
	//mafiajobsoutput();
	//announce("Mafia:" @ %co_mafs SPC "Yakuza:" @ %co_yaks SPC "Civs:" @ %co_civs SPC "Detectives:" @ %co_dets SPC "Trackers:" @ %co_tras SPC "Vigilantes:" @ %co_vigs SPC "Shrinks:" @ %co_shrs SPC "Doctors:" @ %co_docs);
	//announce("Mafia count:" SPC $mafia_mafiacount SPC "Village count:" SPC $mafia_villagecount);


	announce($mafia_announce[$mafia_currentsetup]);
	$mafia_voting=0;
	$Mafia_turn=0;
	nextmafiaturn();
}


function servercmdmafiavote(%client,%name){
	if(!$mafia_voting){
		return;
	}
	if(%client.dead){
		return;
	}
	%cl=findclientbyname(%name);
	if(!isobject(%cl)){
		messageclient(%client,'',"That player does not exist!");
		return;
	}
	if(!%cl.inmafgame){
		%cl.dead=1;
	}
	if(%cl.dead){
		messageclient(%client,'',"That player is dead!");
		return;
	}
	if(%client.voted){
		%client.vote.votes--;
	}
	%client.voted=1;
	%client.vote=%cl;
	%cl.votes++;
	if($Mafia_silentvote){
		announce("A vote was placed on" SPC %cl.name @ ". Votes on" SPC %cl.name @ ":" @ %cl.votes);
	}else{
		announce(%client.name SPC "placed a vote on" SPC %cl.name @ ". Votes on" SPC %cl.name @ ":" @ %cl.votes);
	}
}













package nighttalk
{
function serverCmdMessageSent(%client, %text)
{
	if(%client.dead && $mafia_isnight || %client.dead && $mafia_voting){
		for(%i=0;%i<ClientGroup.getCount();%i++){
			%cl = ClientGroup.getObject(%i);
			if(%cl.dead){
				messageclient(%cl,'',"\c1" @ %client.name SPC "[dead]:\c2" @ %text);
			}
		}
		return;
	}
	if(!$mafia_isnight){
 Parent::serverCmdMessageSent(%client, %text);
	}else{
		if(%client.ismafia){
			for(%i=0;%i<ClientGroup.getCount();%i++){
				%cl = ClientGroup.getObject(%i);
				if(%cl.ismafia){
					messageclient(%cl,'',"\c0" @ %client.name SPC "[mafia]:\c6" @ %text);
				}
			}
		}
		if(%client.talks > 0 && !%client.ismafia){
		if(getrandom(0,1) && %client.talks){
			announce("\c4Someone mumbles:" SPC %text);
		}
		%client.talks--;
		}
		messageclient(%client,'',"You have" SPC %client.talks SPC "messages left.");
		return;
	}
}
function servercmdteammessagesent(%client,%text){
	if(%client.dead){
		for(%i=0;%i<ClientGroup.getCount();%i++){
			%cl = ClientGroup.getObject(%i);
			if(%cl.dead){
				messageclient(%cl,'',"\c1" @ %client.name SPC "[dead]:\c2" @ %text);
			}
		}
		return;
	}
	if($mafia_isnight){
		if(%client.talks > 0){
		if(getrandom(0,1) && %client.talks){
			announce("\c4Someone mumbles:" SPC %text);
		}
		%client.talks--;
		}
		messageclient(%client,'',"You have" SPC %client.talks SPC "messages left.");
		return;
	}
	parent::servercmdteammessagesent(%client,%text);
}
function servercmdsuicide(%client){
	if($mafia_isnight || $mafia_isvoting){
		
		return;
	}
	parent::servercmdsuicide(%client);
}
function serverCmdStartTalking(%client) {serverCmdStopTalking(%client);}
};
activatepackage("nighttalk");

















function servercmdmafia_setsetup(%client,%name){
	if(%client.issuperadmin){
	$mafia_currentsetup=%name;
	$mafia_usesetup=1;
	$mafia_autostart=0;
	announce("Setup is now\c2" SPC %name SPC "\c0 it has:\c2" SPC $mafia_announce[%name]);
	}
}
function mafia_nosetup(%name){
	$mafia_autostart=1;
	$mafia_usesetup=0;
}
//mafia setup
function mafia_addsetup(%name,%roles){
	%i=0;
	$mafia_announce[%name]=%roles;
	while(%i<getwordcount(%roles)){
		%rolename = getword(%roles,%i);
		%rolecount = getword(%roles,%i+1);
		$mafia_roles[%name,%rolename]=%rolecount;
		%i+=2;
	}
}


function servercmdchecksetup(%client,%name){
	messageclient(%client,'',$mafia_announce[%name]);
}

